//+------------------------------------------------------------------+
//|                                                   Dashboard2.mq4 |
//|                                                     Teja Siddani |
//|                                         https://www.tradefxp.com |
//+------------------------------------------------------------------+
#property copyright "Teja Siddani"
#property link      "https://www.tradefxp.com"
#property version   "2.00"
#property description   " Dashboard Indicator:   "
#property description   " GMT Time zones   "
#property description   " Sysmbol Price changes Values with historical data"


#property strict
//#property indicator_chart_window
#property indicator_separate_window
#property indicator_color1     White


extern string ooooooo      = " ------  GMT TIMES ------ "; // ---------------
extern int font_Size_TIME  = 10;    // World Clock Font Size
extern bool ON_Main_Window = False; // World Clock Location On Chart
extern int window_Corner   = 1;     // On Chart Clock Corner

extern string oooooooo     = " ------ Price Dashboard ------ "; // ---------------
extern int font_Size       = 11;    // Dash board Font Size
extern int X_Distance      = 90;    // Table 'X' Distance Gap
extern int Y_Distance      = 30;    // Table 'Y' Distance Gap
input string font_name     = NULL;  // Dash board Font Name 


extern string ooooooooo    = " ------ Dash board Colors ------ "; // ---------------
input color header_color   = DarkGray; // Header Color
input color font_Color     = Gold;     // Font Color
input color positive       = Green;    // Positive Value Color
input color negitive       = Red;      // Negative Value Color
input color Average_Price  = White;    // Average Value Color


int window_Corner_C     =1;
int col                 = Lime;

int todayOC             = col;
int todayHL             = col;
int todayAvg            = col;
int prevOC              = col;
int prevHL              = col;
int prevAvg             = col;
int weekOC              = col;
int weekHL              = col;
int weekAvg             = col;
int monthOC             = col;
int monthHL             = col;
int monthAvg            = col;


int mWindow             = 0;
int price;
int valueOC;
string nameofmonth;
string nameofmonth1;
string nameofmonth2;
string zone;


int dstDelta   = 0;
int LondonTZ   = 1;
int TokyoTZ    = 9;
int NewYorkTZ  = -4;
//+------------------------------------------------------------------+




//+--------- Functions ------------+






//------ Adding to chart ------+
int OnInit()
  {
//--- indicator  mapping
   IndicatorShortName("Dashboard");
    
 
   int win_idx = WindowFind("Dashboard");             // Checking Windows 
   
   
   // Creating Table in Separate window
   for(int x=0;x<11;x++)
      for(int y=0;y<4;y++)
      {
         ObjectCreate("ob"+x+y,OBJ_LABEL,win_idx,0,0,0,0);
         ObjectSet("ob"+x+y,OBJPROP_XDISTANCE,x*(X_Distance+font_Size)+10);
         
               
         // adding a horizontal indent 12 pixels
         ObjectSet("ob"+x+y,OBJPROP_YDISTANCE,y*(Y_Distance+font_Size)+20);
         // adding a vertical indent 20 pixels
         //ObjectSetText("ob"+x+y,"Today",12,"Arial",Gold);
      }
 
   
   
   for(int A=0;A<2;A++)
      for(int B=0;B<6;B++)
      {
         ObjectCreate("time"+A+B,OBJ_LABEL,(ON_Main_Window == True)?0:win_idx,0,0,0,0);
         ObjectSet("time"+A+B,OBJPROP_CORNER,(ON_Main_Window == True)?window_Corner:1);
         ObjectSet("time"+A+B,OBJPROP_XDISTANCE,A*(57+font_Size_TIME)+20);
                        
         // adding a horizontal indent 12 pixels
         ObjectSet("time"+A+B,OBJPROP_YDISTANCE,B*(10+font_Size_TIME)+25);
         // adding a vertical indent 20 pixels
         //ObjectSetText("ob"+x+y,"Today",12,"Arial",Gold);
      }
 
   return(0);
   
   
  
//---
   return(INIT_SUCCEEDED);
  }








//----------------
int start()
{
   
   // Months data
   string months[14] = {"Nov","Dec","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"  }; 
   
   nameofmonth    = months[Month()+1];
   nameofmonth1   = months[Month()];
   nameofmonth2   = months[Month()-1];
  
   
//+--------------- TIme Zone ----------------------+

  

   // -------  Server TIme ------   
   double Server_H         = (Hour()<= 12 )?Hour():Hour()-12;            // IF Time below 12 = time or time -12
   double Server_M         = Minute();
   double brokerGMT        = TimeGMTOffset(); // Nearest hour, no jitter.
     
   
   // AM PM
   string server_Z      = ( Hour() < 12 )?" Am":" Pm";
   string Server_M0     = ( Server_M < 10 )?"0"+Server_M:Server_M;
   
   // Display
   ObjectSetText("time10","Server",font_Size_TIME,NULL,font_Color);
   ObjectSetText("time00",(Server_H ==0)?"00":Server_H + ":" + Server_M0 + server_Z,font_Size_TIME,NULL,Average_Price);
   
   //--------
   
   
   
   int Server_H1  = Server_H+1;
   int Server_M01 = Server_M0+30;
   
   //datetime (TimeCurrent()+1);
   
   string Now     = TimeToStr((TimeCurrent()+1));//   (TimeCurrent(),TIME_MINUTES);
   datetime Now2  = TimeToStr(TimeCurrent(),TIME_SECONDS);
   
   
   
   // -------  Local TIme ------   
   string local_time    = TimeToStr(TimeLocal(),TIME_MINUTES);
   
   int  gap_check       = StrToInteger(StringSubstr(local_time,0,2));
   
   
   int local_time_H  = (gap_check <=12)?gap_check:(gap_check -12);
   int local_time_M  = StringSubstr(local_time,3,4);
   
   // AM PM & 00
   string local_time_Z      = (gap_check < 12)?" Am":" Pm";
   string local_time_M0     = ( local_time_M < 10 )?"0"+local_time_M:local_time_M;
   
   // Display
   ObjectSetText("time11","Local",font_Size_TIME,NULL,font_Color);
   ObjectSetText("time01",(local_time_H == 0)?"00":local_time_H+":"+local_time_M0+local_time_Z,font_Size_TIME,NULL,Average_Price);
   
  
   //--------GMT--
   
   datetime GMT_D    = TimeGMT();                              // GMT DATE & Time
   
   string GMT        = TimeToStr(TimeGMT(),TIME_MINUTES);      // geting GMT time
   int GMT_H         = StrToInteger(StringSubstr(GMT,0,2));    // Taking Hour
   
   
   int GMT_H12       = (GMT_H <=12)?GMT_H:GMT_H-12;             // converting 12hr time
   string GMT_H12_Z  = (GMT_H <12)?" Am":" Pm";              // AM PM check
   
   
   int GMT_M         = StrToInteger(StringSubstr(GMT,3,4));       // Minutes
   string GMT_M0     = (GMT_M <10)?"0"+GMT_M:GMT_M;            // adding 0
   
   
   ObjectSetText("time12","GMT",font_Size_TIME,NULL,font_Color);
   ObjectSetText("time02",(GMT_H12 == 0 )?"00":GMT_H12 +":"+GMT_M0+GMT_H12_Z,font_Size_TIME,NULL,Average_Price);
   
   
   
   
   
   // -------  london TIme ------   
   
   datetime london      = GMT_D + (LondonTZ ) * 3600;                      // Converting to London Date & time     
   
   string gap_uk_Time   = TimeToStr(london,TIME_MINUTES);                  // Sapareting Time
   
   int london_H         = StrToInteger(StringSubstr(gap_uk_Time,0,2));     // taking Hour
   int london_M         = StrToInteger(StringSubstr(gap_uk_Time,3,4));     // taking Minute
   
   
   int london_H12       = (london_H <=12)?london_H:london_H-12;             // converting 12hr time
   string london_H12_Z  = (london_H <12)?" Am":" Pm";              // AM PM check
   
   
   string london_M0     = (london_M <10)?"0"+london_M:london_M;            // adding 0
   
   
   // Display
   ObjectSetText("time13","London",font_Size_TIME,NULL,font_Color);
   ObjectSetText("time03", (london_H12 == 0)?"00":london_H12+":"+london_M0+london_H12_Z,font_Size_TIME,NULL,Average_Price); 
   
   //--------
   
   
   // -------  NewYorkTZ TIme ------   
   
   datetime NewYork      = GMT_D + (NewYorkTZ ) * 3600;                      // Converting to London Date & time     
   
   string NewYork_Time   = TimeToStr(NewYork,TIME_MINUTES);                  // Sapareting Time
   
   int NewYork_H         = StrToInteger(StringSubstr(NewYork_Time,0,2));     // taking Hour
   int NewYork_M         = StrToInteger(StringSubstr(NewYork_Time,3,4));     // taking Minute
   
   
   int NewYork_H12       = (NewYork_H <=12)?NewYork_H:NewYork_H-12;             // converting 12hr time
   string NewYork_H12_Z  = (NewYork_H <12)?" Am":" Pm";              // AM PM check
   
   
   string NewYork_M0     = (NewYork_M <10)?"0"+NewYork_M:NewYork_M;            // adding 0
   
   
   // Display
   ObjectSetText("time14","NewYork",font_Size_TIME,NULL,font_Color);
   ObjectSetText("time04",( NewYork_H12 == 0 )?"00":NewYork_H12 +":"+NewYork_M0+NewYork_H12_Z,font_Size_TIME,NULL,Average_Price); 
   
   //--------
  
   
   // -------  TokyoTZ TIme ------   
   
   datetime Tokyo      = GMT_D + (TokyoTZ ) * 3600;                      // Converting to London Date & time     
   
   string Tokyo_Time   = TimeToStr(Tokyo,TIME_MINUTES);                  // Sapareting Time
   
   int Tokyo_H         = StrToInteger(StringSubstr(Tokyo_Time,0,2));     // taking Hour
   int Tokyo_M         = StrToInteger(StringSubstr(Tokyo_Time,3,4));     // taking Minute
   
   
   int Tokyo_H12       = (Tokyo_H <=12)?Tokyo_H:Tokyo_H-12;             // converting 12hr time
   string Tokyo_H12_Z  = (Tokyo_H <12)?" Am":" Pm";              // AM PM check
   
   
   string Tokyo_M0     = (Tokyo_M <10)?"0"+Tokyo_M:Tokyo_M;            // adding 0
   
   
   // Display
   ObjectSetText("time15","Tokyo",font_Size_TIME,NULL,font_Color);
   ObjectSetText("time05", (Tokyo_H12 == 0)?"00": Tokyo_H12 +":"+Tokyo_M0+Tokyo_H12_Z,font_Size_TIME,NULL,Average_Price); 
   
   //--------
   
//---------------------
   

   
   
   
   
   
   // Table Data model
   ObjectDelete("ob00");
   
    // Side Menu
   ObjectSetText("ob01","Open - Close",font_Size-3,"Arial",header_color);
   ObjectSetText("ob02","High - Low",font_Size-3,"Arial",header_color);
   ObjectSetText("ob03","Average Level",font_Size-3,"Arial",header_color);
   
   // Header text
   ObjectSetText("ob10","Today",font_Size-1,"Arial",font_Color);
   ObjectSetText("ob20","Yesterday",font_Size-2,"Arial",header_color);
   ObjectSetText("ob30","Week",font_Size-1,"Arial",font_Color);
   ObjectSetText("ob40","Week1",font_Size-2,"Arial",header_color);
   ObjectSetText("ob50","Week2",font_Size-2,"Arial",header_color);
   ObjectSetText("ob60","Week3",font_Size-2,"Arial",header_color);
   ObjectSetText("ob70","Week4",font_Size-2,"Arial",header_color);
   ObjectSetText("ob80",nameofmonth,font_Size-1,"Arial",font_Color);
   ObjectSetText("ob90",nameofmonth1,font_Size-2,"Arial",header_color);
   ObjectSetText("ob100",nameofmonth2,font_Size-2,"Arial",header_color);
   
   
   // Close - Open
   double today   = (iClose(NULL,PERIOD_D1,0)- iOpen(NULL,PERIOD_D1,0));
   double prev    = (iClose(NULL,PERIOD_D1,1))-(iOpen(NULL,PERIOD_D1,1));
   double week    = (iClose(NULL,PERIOD_W1,0))-(iOpen(NULL,PERIOD_W1,0));
   double Week1   = (iClose(NULL,PERIOD_W1,1))-(iOpen(NULL,PERIOD_W1,1));
   double Week2   = (iClose(NULL,PERIOD_W1,2))-(iOpen(NULL,PERIOD_W1,2));
   double Week3   = (iClose(NULL,PERIOD_W1,3))-(iOpen(NULL,PERIOD_W1,3));
   double Week4   = (iClose(NULL,PERIOD_W1,4))-(iOpen(NULL,PERIOD_W1,4));
   double month   = (iClose(NULL,PERIOD_MN1,0))-(iOpen(NULL,PERIOD_MN1,0));
   double month1  = (iClose(NULL,PERIOD_MN1,1))-(iOpen(NULL,PERIOD_MN1,1));
   double month2  = (iClose(NULL,PERIOD_MN1,2))-(iOpen(NULL,PERIOD_MN1,2));
   
 
   // High - Low
   double HLT     = (iHigh(NULL,PERIOD_D1,0) - iLow(NULL,PERIOD_D1,0));
   double HLY     = (iHigh(NULL,PERIOD_D1,1) - iLow(NULL,PERIOD_D1,1));
   double HLW     = (iHigh(NULL,PERIOD_W1,0) - iLow(NULL,PERIOD_W1,0));
   double HLW1    = (iHigh(NULL,PERIOD_W1,1) - iLow(NULL,PERIOD_W1,1));
   double HLW2    = (iHigh(NULL,PERIOD_W1,2) - iLow(NULL,PERIOD_W1,2));
   double HLW3    = (iHigh(NULL,PERIOD_W1,3) - iLow(NULL,PERIOD_W1,3));
   double HLW4    = (iHigh(NULL,PERIOD_W1,4) - iLow(NULL,PERIOD_W1,4));
   double HLMN    = (iHigh(NULL,PERIOD_MN1,0) - iLow(NULL,PERIOD_MN1,0));
   double HLMN1   = (iHigh(NULL,PERIOD_MN1,1) - iLow(NULL,PERIOD_MN1,1));
   double HLMN2   = (iHigh(NULL,PERIOD_MN1,2) - iLow(NULL,PERIOD_MN1,2));
   
   // HIgh + Low + Close / 3
   double  avgT      = ((iHigh(NULL,PERIOD_D1,0)+ iLow(NULL,PERIOD_D1,0)+ iClose(NULL,PERIOD_D1,0))/3);
   double  avgY      = ((iHigh(NULL,PERIOD_D1,1)+ iLow(NULL,PERIOD_D1,1)+ iClose(NULL,PERIOD_D1,1))/3);
   double  avgW      = ((iHigh(NULL,PERIOD_W1,0)+ iLow(NULL,PERIOD_W1,0)+ iClose(NULL,PERIOD_W1,0))/3);
   double  avgW1     = ((iHigh(NULL,PERIOD_W1,1)+ iLow(NULL,PERIOD_W1,1)+ iClose(NULL,PERIOD_W1,1))/3);
   double  avgW2     = ((iHigh(NULL,PERIOD_W1,2)+ iLow(NULL,PERIOD_W1,2)+ iClose(NULL,PERIOD_W1,1))/3);
   double  avgW3     = ((iHigh(NULL,PERIOD_W1,3)+ iLow(NULL,PERIOD_W1,3)+ iClose(NULL,PERIOD_W1,1))/3);
   double  avgW4     = ((iHigh(NULL,PERIOD_W1,4)+ iLow(NULL,PERIOD_W1,4)+ iClose(NULL,PERIOD_W1,1))/3);
   double  avgMN     = ((iHigh(NULL,PERIOD_MN1,0)+ iLow(NULL,PERIOD_MN1,0)+ iClose(NULL,PERIOD_W1,1))/3);
   double  avgMN1    = ((iHigh(NULL,PERIOD_MN1,1)+ iLow(NULL,PERIOD_MN1,1)+ iClose(NULL,PERIOD_W1,1))/3);
   double  avgMN2    = ((iHigh(NULL,PERIOD_MN1,2)+ iLow(NULL,PERIOD_MN1,2)+ iClose(NULL,PERIOD_W1,1))/3);
   
  
   
   //*SymbolInfoDouble(NULL,SYMBOL_TRADE_TICK_VALUE))*SymbolInfoDouble(NULL,SYMBOL_TRADE_CONTRACT_SIZE))
   
   // Open - close
   ObjectSetText("ob11","$ "+DoubleToStr((today),Digits),font_Size,font_name,(today >=0)?positive:negitive);
   ObjectSetText("ob21","$ "+DoubleToStr((prev),Digits),font_Size,font_name,(prev >=0)?positive:negitive);
   ObjectSetText("ob31","$ "+DoubleToStr((week),Digits),font_Size,font_name,(week >=0)?positive:negitive);
   ObjectSetText("ob41","$ "+DoubleToStr((Week1),Digits),font_Size,font_name,(Week1 >=0)?positive:negitive);
   ObjectSetText("ob51","$ "+DoubleToStr((Week2),Digits),font_Size,font_name,(Week2 >=0)?positive:negitive);
   ObjectSetText("ob61","$ "+DoubleToStr((Week3),Digits),font_Size,font_name,(Week3 >=0)?positive:negitive);
   ObjectSetText("ob71","$ "+DoubleToStr((Week4),Digits),font_Size,font_name,(Week4 >=0)?positive:negitive);
   ObjectSetText("ob81","$ "+DoubleToStr((month),Digits),font_Size,font_name,(month >0)?positive:negitive);
   ObjectSetText("ob91","$ "+DoubleToStr((month1),Digits),font_Size,font_name,(month1 >=0)?positive:negitive);
   ObjectSetText("ob101","$ "+DoubleToStr((month2),Digits),font_Size,font_name,(month2 >=0)?positive:negitive);
   
    // High - Low
   ObjectSetText("ob12","$ "+DoubleToStr((HLT),Digits),font_Size,font_name,(HLT >=0)?positive:negitive);
   ObjectSetText("ob22","$ "+DoubleToStr((HLY),Digits),font_Size,font_name,(HLY >=0)?positive:negitive);
   ObjectSetText("ob32","$ "+DoubleToStr((HLW),Digits),font_Size,font_name,(HLW >=0)?positive:negitive);
   ObjectSetText("ob42","$ "+DoubleToStr((HLW1),Digits),font_Size,font_name,(HLW1 >=0)?positive:negitive);
   ObjectSetText("ob52","$ "+DoubleToStr((HLW2),Digits),font_Size,font_name,(HLW2 >=0)?positive:negitive);
   ObjectSetText("ob62","$ "+DoubleToStr((HLW3),Digits),font_Size,font_name,(HLW3 >=0)?positive:negitive);
   ObjectSetText("ob72","$ "+DoubleToStr((HLW4),Digits),font_Size,font_name,(HLW4 >=0)?positive:negitive);
   ObjectSetText("ob82","$ "+DoubleToStr((HLMN),Digits),font_Size,font_name,(HLMN >=0)?positive:negitive);
   ObjectSetText("ob92","$ "+DoubleToStr((HLMN1),Digits),font_Size,font_name,(HLMN1 >=0)?positive:negitive);
   ObjectSetText("ob102","$ "+DoubleToStr((HLMN2),Digits),font_Size,font_name,(HLMN2 >=0)?positive:negitive);

  // aVEG - Low
   ObjectSetText("ob13",DoubleToStr(avgT,Digits),font_Size,font_name,Average_Price);
   ObjectSetText("ob23",DoubleToStr(avgY,Digits),font_Size,font_name,Average_Price);
   ObjectSetText("ob33",DoubleToStr(avgW,Digits),font_Size,font_name,Average_Price);
   ObjectSetText("ob43",DoubleToStr(avgW1,Digits),font_Size,font_name,Average_Price);
   ObjectSetText("ob53",DoubleToStr(avgW2,Digits),font_Size,font_name,Average_Price);
   ObjectSetText("ob63",DoubleToStr(avgW3,Digits),font_Size,font_name,Average_Price);
   ObjectSetText("ob73",DoubleToStr(avgW4,Digits),font_Size,font_name,Average_Price);
   ObjectSetText("ob83",DoubleToStr(avgMN,Digits),font_Size,font_name,Average_Price);
   ObjectSetText("ob93",DoubleToStr(avgMN1,Digits),font_Size,font_name,Average_Price);
   ObjectSetText("ob103",DoubleToStr(avgMN2,Digits),font_Size,font_name,Average_Price);
   






   return(0);
} 
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
  
 // int font_Color = indicator_color1;
   
   
//--- return value of prev_calculated for next call
   return(rates_total);
   
   
   
 
   
   
   
   
   
  // Adding text
  ObjectDelete("ob00");
  ObjectSetText("Today","Today",font_Size,"Arial",Gold);
  ObjectSetText("Yesterday","Yesterday",font_Size,"Arial",Gold);
  ObjectSetText("Weekly","Weekly",font_Size,"Arial",Gold);
  ObjectSetText("Month","Month",font_Size,"Arial",Gold);


  
  ObjectSetText("HL","HL",font_Size,"Arial",Gold);
  ObjectSetText("Avg","Avg",font_Size,"Arial",Gold);
  
 
  ObjectSetText("HL","HL",font_Size,"Arial",Gold);
  ObjectSetText("Avg","Avg",font_Size,"Arial",Gold);
   
   
   
 
 
 
  }
//+------------------------------------------------------------------+
int deinit()
  {
 
   for(int x=0;x<11;x++)
      for(int y=0;y<4;y++)
      {
         ObjectDelete("ob"+x+y);
         
      }
 
   
   for(int A=0;A<2;A++)
      for(int B=0;B<6;B++)
      {
         ObjectDelete("time"+A+B);
         
      }
 
   //----
  
//----

   return(0);
   
   
  }
